#include<dos.h>
#include<stdlib.h>
#include<stdio.h>


int Read(int Pout)
{
 int Wert;
 outportb(0x224,Pout);
 delay(1);
 Wert=inportb(0x225);
 delay(1);
 return Wert;
}


void Write(int Pout,int Wert)
{
 outportb(0x224,Pout);
 delay(1);
 outportb(0x225,Wert);
 delay(1);
}


void main(int argc,char *argv[])
{
 int a,b=32,c;
 if(argc<4)
           {
            puts("\n MIXER, Public Domain written by Lars Otte\n-------------------------------------------\n");
            puts("mixer  INfilter  OUTfilter  mic/line/cd  -v15  -l15  -m7  -d15  -f15  -c15\n");
            puts("INfilter(4kHz/8kHz/no) = 1/2/3\n");
            puts("OUTfilter(4kHz) = 1/0");
            a=Read(0x22);
            printf("\n-v = Mastervolume:   %d,%d",(a>>4)&15,a&15);
            a=Read(0x2e);
            printf("\n-l = Line-IN:        %d,%d",(a>>4)&15,a&15);
            a=Read(0x0a);
            printf("\n-m = Microphone-IN:  %d",             a&15);
            a=Read(0x04);
            printf("\n-d = DAC-Volume:     %d,%d",(a>>4)&15,a&15);
            a=Read(0x26);
            printf("\n-f = FM-Synthesizer: %d,%d",(a>>4)&15,a&15);
            a=Read(0x28);
            printf("\n-c = CD Audio:       %d,%d",(a>>4)&15,a&15);
            a=Read(0x0c);
            printf("\n\nInput source:  ");
            switch(a&6)
             {
              case 0: printf("Microphone\n"); break;
              case 2: printf("CD Audio\n"); break;
              case 4: printf("Microphone\n"); break;
              case 6: printf("Line\n"); break;
              default: printf("\n"); break;
             }
            printf("Input filter:  ");
            switch(a&0x28)
             {
              case 0x00: printf("4kHz filter\n"); break;
              case 0x08: printf("8kHz filter\n"); break;
              case 0x20:
              case 0x28: printf("No filter\n"); break;
              default: printf("\n"); break;
             }
            a=Read(0x0e);
            if((a&32)==0)printf("Output filter:  4kHz\n");
            if(a&2) printf("Stereo voice mode\n"); else printf("Mono voice mode\n");
            return;
           }
Write(0,0xff);      //Reset Mixer complete...
Write(1,0x11);      //Maximum Volume possible...
Write(0x20,0x1b);   //disable Feedback-danger over mic & line

a=atoi(argv[1]);
if(a==1)b=0;
if(a==2)b=8;

c=Read(0x0e);
if(argv[2][0]=='1') c&=32; else c|=32;
Write(0x0e,c);

if(argv[3][0]=='c')b=b+2;
if(argv[3][0]=='l')b=b+6;
Write(0x0c,b);

for(c=4;c<argc;c++)
   {
    if(argv[c][1]=='m'){a=atoi(&(argv[c][2])); Write(0x0a,a); }
    if(argv[c][1]=='l'){a=atoi(&(argv[c][2])); a=a|(a<<4); Write(0x2e,a); }
    if(argv[c][1]=='v'){a=atoi(&(argv[c][2])); a=a|(a<<4); Write(0x22,a); }
    if(argv[c][1]=='d'){a=atoi(&(argv[c][2])); a=a|(a<<4); Write(0x04,a); }
    if(argv[c][1]=='f'){a=atoi(&(argv[c][2])); a=a|(a<<4); Write(0x26,a); }
    if(argv[c][1]=='c'){a=atoi(&(argv[c][2])); a=a|(a<<4); Write(0x28,a); }
   }
}
